# Based on https://github.com/Rob--W/open-in-browser/issues/28#issuecomment-347048056
try:
    from socketserver import TCPServer, BaseRequestHandler
except ImportError:  # Py2
    from SocketServer import TCPServer, BaseRequestHandler
import ssl
import time

#body = open('foo.pdf', 'rb').read()
body = b'x' * 13230
head = b'''HTTP/1.1 200 OK
Content-Type: application/pdf
Content-Disposition: attachment; filename="foo.pdf"
Content-Length: %d
Connection: close

''' % len(body)

PORT = 4433
class Handler(BaseRequestHandler):
    def setup(self):
        self.raw_sock = self.request
        self.request = ssl.wrap_socket(self.request, certfile='server.pem',
                server_side=True)

    def handle(self):
        sock = self.request
        sock.recv()
        response = head.replace(b'\n', b'\r\n') + body
        size = 1024
        while response:
            chunk, response = response[:size], response[size:]
            self.request.write(chunk)
            time.sleep(.01)

    def finish(self):
        self.raw_sock.close()


try:
    with TCPServer(("", PORT), Handler) as svr:
        svr.serve_forever()
except AttributeError:  # Py2
    TCPServer(("", PORT), Handler).serve_forever()

